SystemOrganization addCategory: #'SourceCity-OpenGL'!

GLViewportMorph subclass: #GLCity
	instanceVariableNames: 'rotationAngle textId xrot yrot zrot face top down xtran ytran ztran znumb ynumb xnumb grass model frameCount font frameStats start configuration lastMousePosition curveRenderer glyphCache pickingBuf displayForUI selectedBuilding conten'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!GLCity commentStamp: '<historical>' prior: 0!
A GLCity is a class which display the city with OpenGL, this class use camera and key handler!

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 5/29/2012 10:55'!
applyCamera
	display gl translatef_x: xtran y: ytran z: ztran. 
	display gl  rotatef_angle: configuration cameraXPos x: 1 y: 0  z: 0. 
	display gl rotatef_angle: configuration cameraYPos x: 0 y: 1  z: 0. 
	display gl rotatef_angle: configuration cameraZPos x: 0 y: 0  z: 1. 
	"display gl translatef_x: xtran withNegativeSign  y: ytran withNegativeSign z: ztran withNegativeSign. "
! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwans 5/2/2012 11:06'!
buildingColor: anArray color: aColor
		self buildingColor: anArray color: aColor width: 1! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 5/23/2012 15:48'!
buildingColor: anArray color: aColor width: aWidthSelector
		self drawFace: anArray color: aColor width: aWidthSelector.
		self drawBack: anArray color: aColor width: aWidthSelector.
		self drawLeft: anArray color: aColor width: aWidthSelector.
		self drawRight: anArray color: aColor width: aWidthSelector.
		self drawDown: anArray color: aColor width: aWidthSelector.
		self drawTop: anArray color: aColor width: aWidthSelector.
		self drawBorder: anArray width: aWidthSelector.
	! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 5/22/2012 16:39'!
buildingPicking: anArray width: aWidthSelector building: building
	|gl x z y r g b id |
	
	gl := display gl.
	id := building id.
	r := id bitAnd: 255.
	g := id >> 8 bitAnd: 255.  " id // (2^8) "
	b := id >>16 bitAnd: 255.
		
	gl begin: GL_QUADS.
	gl color3ub_red:  r green: g  blue:  b.
		
		"front"			
		self vertex: { anArray first . 0 . anArray third }.
		self vertex: { anArray first . anArray second . anArray third }.
		self vertex: { (anArray first)+aWidthSelector . anArray second . anArray third } .
		self vertex: { (anArray first)+aWidthSelector . 0 . anArray third }.
		
		"back"
		self vertex: { anArray first . 0 . (anArray third)+aWidthSelector } .
		self vertex: { (anArray first)+aWidthSelector . 0 . (anArray third)+aWidthSelector } .
		self vertex: { (anArray first)+aWidthSelector . anArray second . (anArray third)+aWidthSelector } .
		self vertex: { anArray first . anArray second . (anArray third)+aWidthSelector }.
	
		"left maybe reverse with right"
		self vertex: { (anArray first)+aWidthSelector . 0 . anArray third } .
		self vertex: { (anArray first)+aWidthSelector . anArray second . anArray third } .
		self vertex: { (anArray first)+aWidthSelector . anArray second . (anArray third)+aWidthSelector } .
		self vertex: { (anArray first)+aWidthSelector . 0 . (anArray third)+aWidthSelector }.
	
		"right maybe reverse with left"
		self vertex: { anArray first . 0 . (anArray third)+aWidthSelector } .
		self vertex: { anArray first . anArray second . (anArray third)+aWidthSelector } .
		self vertex: { anArray first . anArray second . anArray third } .
		self vertex: { anArray first . 0 . anArray third } .
		
		"down"
		self vertex: { anArray first . 0 . anArray third } .
		self vertex: { (anArray first)+aWidthSelector . 0 . anArray third } .
		self vertex: { (anArray first)+aWidthSelector . 0 . (anArray third)+aWidthSelector } .
		self vertex: { anArray first . 0 . (anArray third)+aWidthSelector }.
		
		"top"
		self vertex: { anArray first . anArray second . anArray third }.
		self vertex: { anArray first . anArray second . (anArray third)+aWidthSelector } .
		self vertex: { (anArray first)+aWidthSelector . anArray second . (anArray third)+aWidthSelector } .
		self vertex: { (anArray first)+aWidthSelector . anArray second . anArray third } .
	gl end.! !

!GLCity methodsFor: 'control' stamp: 'DouailleErwan 5/22/2012 14:44'!
captureKey: e

	(e keyString = '<left>')
		ifTrue:[ self rotateLeft].
	(e keyString  = '<down>')
		ifTrue:[self rotateDown].
	(e keyString  = '<up>')
		ifTrue:[self rotateTop].
	(e keyString  = '<right>')
		ifTrue:[self rotateRight].
	(e keyString  = '<Shift-right>')
		ifTrue:[self translateRight].
	(e keyString  = '<Shift-left>')
		ifTrue:[self translateLeft].
	(e keyString  = '<Shift-up>')
		ifTrue:[self translateTop].
	(e keyString  = '<Shift-down>')
		ifTrue:[self translateDown].
	(e keyString  = ' ')
		ifTrue:[self translateForward].
	(e keyString  = 'c' )
		ifTrue:[self translateBackward].! !

!GLCity methodsFor: 'control' stamp: 'DouailleErwan 5/25/2012 15:53'!
captureMouseDown: e
	| x y  pixel tmp |
	 x := (e position x) - self position x.
	 y := (e position y) - self position y.
	tmp :=0.
	displayForUI := true.
	self drawCity: model.
	display gl 
		disable: GL_MULTISAMPLE ;
		disable: GL_BLEND;
		disable: GL_POLYGON_SMOOTH;
		disable: GL_NORMALIZE;
		clearDepth: 1; 
	 	disable: GL_DEPTH_TEST;
		shadeModel: GL_FLAT;
		flush.
	pixel := display readPixel: x@y.	
	displayForUI := false.
	tmp := (pixel asInteger ).
	"Transcript cr;show: pixel asInteger hex.
	Transcript cr;show: pixel printString."
	tmp := (pixel at:1)*256 + (pixel at:2)*256 + (pixel at:3).
	"Transcript cr;show: tmp."
	model buildingsPicking at: tmp ifPresent: [ selectedBuilding := model buildingsPicking at: tmp.
	conten contents: selectedBuilding model asString, Character cr asString,Character cr asString,
						'Selectors : ', selectedBuilding model selectors size asString, Character cr asString,
						'VarInst : ', selectedBuilding model allInstVarNames size asString, Character cr asString,
						'VarClass : ', selectedBuilding model allClassVarNames size asString, Character cr asString,Character cr asString,
						'District : ', selectedBuilding district model asString, Character cr asString,
						'City : ', selectedBuilding district city model asString, Character cr asString.].
	 
	"model buildingsPicking at: tmp ifPresent: [ (selectedBuilding ~= (model buildingsPicking at: tmp)) ifTrue: [selectedBuilding := model buildingsPicking at: tmp] ifFalse: [selectedBuilding := nil]. ]."! !

!GLCity methodsFor: 'control' stamp: 'DouailleErwan 5/9/2012 10:37'!
captureMouseStillDown: e
	(self lastMousePosition x > (e position - self position) x)
		ifTrue: [self rotateLeft].
	(self lastMousePosition x < (e position - self position) x)
		ifTrue:[self rotateRight].
	(self lastMousePosition y < (e position - self position) y)
		ifTrue:[self rotateTop].
	(self lastMousePosition y > (e position - self position) y)
		ifTrue:[self rotateDown].
	self lastMousePosition: (e position - self position).! !

!GLCity methodsFor: 'accessing' stamp: 'DouailleErwan 5/3/2012 16:25'!
changeConfiguration: aCityConfiguration
	configuration := aCityConfiguration.
	model := configuration model.! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 4/17/2012 17:25'!
city: anArrayStart to: anArrayEnd
	|gl|
	
	gl := display gl.
	gl enable: GL_TEXTURE_2D.
	
	gl bindTexture_target: GL_TEXTURE_2D texture: city. 			
	gl begin: GL_QUADS.
		
		self vertex: { anArrayStart first . anArrayStart second . anArrayStart third } texCoord: #(0 0).
		self vertex: { anArrayEnd first . anArrayStart second . anArrayStart third } texCoord: #(1 0).
		self vertex: { anArrayEnd first . anArrayStart second . anArrayEnd third } texCoord: #(1 1).
		self vertex: { anArrayStart first . anArrayStart second . anArrayEnd third } texCoord: #(0 1).

	gl end.
	! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 5/2/2012 15:06'!
cityColor: anArrayStart to: anArrayEnd color: aColor
	|gl|
	gl := display gl.	
	gl begin: GL_QUADS;
		color3f_red: aColor red green: aColor green blue: aColor blue; 
		vertex3d_x: anArrayStart first y: anArrayStart second z: anArrayStart third;
		vertex3d_x: anArrayEnd first y: anArrayStart second z: anArrayStart third;
		vertex3d_x: anArrayEnd first y: anArrayStart second z: anArrayEnd third;
		vertex3d_x: anArrayStart first y: anArrayStart second z: anArrayEnd third;
	end.
	! !

!GLCity methodsFor: 'initialize' stamp: 'DouailleErwan 5/29/2012 10:56'!
default: aCityConfiguration
	configuration := aCityConfiguration.
	model := configuration model.
	xtran := 0.
	ytran := 30.
	ztran := -384.! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 4/17/2012 17:24'!
district: anArrayStart to: anArrayEnd
	|gl|
	gl := display gl.
	gl enable: GL_TEXTURE_2D.
	gl bindTexture_target: GL_TEXTURE_2D texture: district. 	
	gl begin: GL_QUADS.

		self vertex: { anArrayStart first . anArrayStart second . anArrayStart third } texCoord: #(0 0).
		self vertex: { anArrayEnd first . anArrayStart second . anArrayStart third } texCoord: #(1 0).
		self vertex: { anArrayEnd first . anArrayStart second . anArrayEnd third } texCoord: #(1 1).
		self vertex: { anArrayStart first . anArrayStart second . anArrayEnd third } texCoord: #(0 1).
		
		self vertex: { anArrayStart first . anArrayEnd second . anArrayStart third } texCoord: #(0 0).
		self vertex: { anArrayStart first . anArrayEnd second . anArrayEnd third } texCoord: #(1 0).
		self vertex: { anArrayEnd first . anArrayEnd second . anArrayEnd third } texCoord: #(1 1).
		self vertex: { anArrayEnd first . anArrayEnd second . anArrayStart third } texCoord: #(0 1).

	gl end.	! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 5/15/2012 12:46'!
districtColor: anArrayStart to: anArrayEnd color: aColor
	|gl|
	gl := display gl.
	gl begin: GL_QUADS;
		color3f_red: aColor red green: aColor green blue: aColor blue; 
		vertex3d_x: anArrayStart first y: anArrayStart second z: anArrayStart third;
		vertex3d_x: anArrayEnd first y: anArrayStart second z: anArrayStart third;
		vertex3d_x: anArrayEnd first y: anArrayStart second z: anArrayEnd third;
		vertex3d_x: anArrayStart first y: anArrayStart second z: anArrayEnd third;
	end.! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 5/23/2012 22:10'!
drawBack: anArray color: aColor width: aWidthSelector
	|gl x z y minColor |
	gl := display gl.
	gl begin: GL_QUADS;
		color3f_red: aColor red green: aColor green blue: aColor blue; 
		vertex3d_x:  anArray first y: 0.1 z: (anArray third)+aWidthSelector;
		vertex3d_x:  (anArray first)+aWidthSelector y: 0.1 z: (anArray third)+aWidthSelector;
		vertex3d_x:  (anArray first)+aWidthSelector y: anArray second z: (anArray third)+aWidthSelector;
		vertex3d_x:  anArray first y: anArray second z: (anArray third)+aWidthSelector;
	end.! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 5/11/2012 10:43'!
drawBorder: anArray 
	|gl|
	gl := display gl.
	gl begin: GL_LINES;

		color3f_red: 0 green: 0 blue: 0; 
		vertex3f_x: anArray first y: 0.1 z: anArray third;
		vertex3f_x: anArray first y: anArray second z: anArray third;
		
	end.
	! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 5/11/2012 11:22'!
drawBorder: anArray width: aWidthSelector
	|gl|
	gl := display gl.
	gl begin: GL_LINES;

		color3f_red: 0 green: 0 blue: 0; 
		vertex3f_x: anArray first y: 0.1 z: anArray third;
		vertex3f_x: anArray first y: anArray second z: anArray third;
		
		vertex3f_x: anArray first y: 0.1 z: (anArray third)+aWidthSelector;
		vertex3f_x: anArray first y: anArray second z: (anArray third)+aWidthSelector;
		
		vertex3f_x: (anArray first)+aWidthSelector y: anArray second z: anArray third;
		vertex3f_x: (anArray first)+aWidthSelector y: 0.1 z: anArray third;
		
		vertex3f_x: (anArray first)+aWidthSelector y: 0.1 z: (anArray third)+aWidthSelector;
		vertex3f_x: (anArray first)+aWidthSelector y: anArray second z: (anArray third)+aWidthSelector;
		
		vertex3f_x: anArray first y: 0.1 z: anArray third;
		vertex3f_x: anArray first y: 0.1 z: (anArray third)+aWidthSelector;
		
		vertex3f_x: anArray first y: anArray second z: anArray third;
		vertex3f_x: anArray first y: anArray second z: (anArray third)+aWidthSelector;
		
		vertex3f_x: (anArray first)+aWidthSelector y: anArray second z: anArray third;
		vertex3f_x: (anArray first)+aWidthSelector y: anArray second z: (anArray third)+aWidthSelector;
		
		vertex3f_x: (anArray first)+aWidthSelector y: 0.1 z: anArray third;
		vertex3f_x: (anArray first)+aWidthSelector y: 0.1 z: (anArray third)+aWidthSelector;
		
		vertex3f_x: anArray first y: anArray second z: anArray third;
		vertex3f_x: (anArray first)+aWidthSelector y: anArray second z: anArray third;
		
		vertex3f_x: anArray first y: 0.1 z: anArray third;
		vertex3f_x: (anArray first)+aWidthSelector y: 0.1 z: anArray third;
		
		vertex3f_x: anArray first y: anArray second z: (anArray third)+aWidthSelector;
		vertex3f_x: (anArray first)+aWidthSelector y: anArray second z: (anArray third)+aWidthSelector;
		
		vertex3f_x: anArray first y: 0.1 z: (anArray third)+aWidthSelector;
		vertex3f_x: (anArray first)+aWidthSelector y: 0.1 z: (anArray third)+aWidthSelector;
		
	end.! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 5/23/2012 14:20'!
drawBuilding: aDistrict gap: buildingGap x: x z: z dxSize: dxSize
	| bxSize bzSize zmax buildingColor |
	bxSize := x +1 .
	bzSize := z +1.
	zmax := 0.
	aDistrict buildings do: [:building |
		(dxSize < (bxSize+ (building width)))
		ifTrue: [
			bzSize := bzSize + zmax + buildingGap.
			bxSize := x + 1.
			].
		(zmax<(building width))
		ifTrue:[zmax := (building width)].
		(displayForUI)
		ifTrue: [self buildingPicking: { bxSize . (building height) . bzSize } width: (building width) building: building.]
		ifFalse: [
			buildingColor := building color.
			(selectedBuilding == building)
			ifTrue: [buildingColor := Color white ].
			self buildingColor: { bxSize . (building height) . bzSize } color: buildingColor width: (building width)..
			].
		bxSize := bxSize + buildingGap + (building width).
	].
	^bzSize+zmax+1.! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 5/29/2012 10:56'!
drawCity: anImporter
	|sizeArray|
	sizeArray := self drawDistrict: anImporter city gap: configuration districtGap.
	self cityColor: {-1 . -0.1 . -1} to: sizeArray color: configuration cityColor.! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 5/23/2012 14:00'!
drawDistrict:aCity gap: gap
	| dxSize x dzSize z maxdxSize maxdzSize bxSize bzSize buildingGap |
	x := 0.
	z := 0.
	buildingGap := configuration buildingGap.
	(configuration buildingGap<1)
	ifTrue: [buildingGap := 1.] 
	ifFalse: [buildingGap := configuration buildingGap].
	maxdzSize := 0.
	maxdxSize := 0.
	aCity districts do:[:district |
		dxSize := x + ((district width) *buildingGap+1).
		dzSize := self drawBuilding: district gap: buildingGap x: x z: z dxSize: dxSize.
		self districtColor: {x . 0.1 . z} to: {dxSize . 0.1 . dzSize} color: configuration districtColor.
		(maxdzSize < dzSize)
		ifTrue: [ maxdzSize := dzSize].
		x := dxSize + gap.
		( x > aCity width)
		ifTrue: [
			z := maxdzSize + gap.
			(maxdxSize<x)
			ifTrue: [maxdxSize := x+(dxSize - x).].
			x := 0.
		]
		ifFalse: [
			(maxdxSize<x)
			ifTrue: [maxdxSize := x.].
		].
	].
	^{maxdxSize+1 . 0 . maxdzSize+1}! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 5/23/2012 22:10'!
drawDown: anArray color: aColor width: aWidthSelector
	|gl x z y minColor |
	gl := display gl.
	gl enable: GL_NORMALIZE .
	gl begin: GL_QUADS;
		color3f_red: aColor red green: aColor green blue: aColor blue; 
		vertex3d_x:  anArray first y: 0.1 z: anArray third;
		vertex3d_x:  (anArray first)+aWidthSelector y: 0.1 z: anArray third;
		vertex3d_x:  (anArray first)+aWidthSelector y: 0.1 z: (anArray third)+aWidthSelector;
		vertex3d_x:  anArray first y: 0.1 z: (anArray third)+aWidthSelector;
	end.! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 5/23/2012 22:10'!
drawFace: anArray color: aColor width: aWidthSelector
	|gl x z y minColor b n |
	gl := display gl.
	gl begin: GL_QUADS;
		color3f_red: aColor red green: aColor green blue: aColor blue; 
		vertex3d_x: anArray first y: 0.1 z: anArray third;
		vertex3d_x: anArray first y: anArray second z: anArray third;
		vertex3d_x: (anArray first)+aWidthSelector y: anArray second z: anArray third;
		vertex3d_x: (anArray first)+aWidthSelector y: 0.1 z: anArray third;
	end.! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 5/23/2012 22:10'!
drawLeft: anArray color: aColor width: aWidthSelector
	|gl x z y minColor |
	gl := display gl.
	gl begin: GL_QUADS;
		color3f_red: aColor red green: aColor green blue: aColor blue; 
		vertex3d_x:  (anArray first)+aWidthSelector y: 0.1 z: anArray third;
		vertex3d_x:  (anArray first)+aWidthSelector y: anArray second z: anArray third;
		vertex3d_x:  (anArray first)+aWidthSelector y: anArray second z: (anArray third)+aWidthSelector;
		vertex3d_x:  (anArray first)+aWidthSelector y: 0.1 z: (anArray third)+aWidthSelector;
	end.! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 5/23/2012 22:10'!
drawRight: anArray color: aColor width: aWidthSelector
	|gl x z y minColor |
	gl := display gl.
	gl begin: GL_QUADS;
		color3f_red: aColor red green: aColor green blue: aColor blue; 
		vertex3d_x:  anArray first y: 0.1 z: (anArray third)+aWidthSelector;
		vertex3d_x:  anArray first y: anArray second z: (anArray third)+aWidthSelector;
		vertex3d_x:  anArray first y: anArray second z: anArray third ;
		vertex3d_x:  anArray first y: 0.1 z: anArray third ;
	end.! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 5/23/2012 15:47'!
drawText: aString to: anArray
	| gl x |
	gl := display gl.
	curveRenderer ifNotNil: [  | g adv |
		gl color3f_red: 0 green:  0 blue: 0. 
		gl pushMatrix.
		gl scalef_x: 1000 y: 1000  z: 1.
		gl translatef_x: 0 y: 0  z: 0. 
		adv := 0.
		aString asString do:  [:ch |
			g := font at: ch.
			glyphCache renderGlyph: g.
			adv := adv + g advanceWidth.
			gl translatef_x: g advanceWidth y: 0 z:0.
		].
		gl popMatrix.
	].
	
! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 5/23/2012 22:10'!
drawTop: anArray color: aColor width: aWidthSelector
	|gl x z y minColor |
	gl := display gl.
	gl begin: GL_QUADS;
		color3f_red: aColor red green: aColor green blue: aColor blue; 
		vertex3d_x: anArray first y: anArray second z: anArray third ;
		vertex3d_x: anArray first y: anArray second z: (anArray third)+aWidthSelector;
		vertex3d_x: (anArray first)+aWidthSelector y: anArray second z: (anArray third)+aWidthSelector;
		vertex3d_x: (anArray first)+aWidthSelector y: anArray second z: anArray third ;
	end.! !

!GLCity methodsFor: 'control' stamp: 'DouailleErwan 5/22/2012 14:18'!
handleMouseMove: anEvent
	"System level event handling."
	anEvent wasHandled ifTrue:[^self]. "not interested"
	anEvent wasHandled: true.

	anEvent anyButtonPressed ifTrue: [
		self captureMouseStillDown: anEvent
		].
! !

!GLCity methodsFor: 'initialize' stamp: 'DouailleErwan 6/4/2012 12:25'!
initialize
	| fontPath |
	super initialize.
	lastMousePosition := Point x: 0 y:0.
	displayForUI := false.
	self on: #keyStroke send: #captureKey: to: self.
	self on: #mouseDown send: #captureMouseDown: to: self.
	fontPath := self platformDefaultFontsPath.	
	font := NBTTFontReader readFrom:  
		(FileStream readOnlyFileNamed: fontPath , 'Tahoma.ttf').
	! !

!GLCity methodsFor: 'session management' stamp: 'DouailleErwan 5/22/2012 14:41'!
initializeForNewSession
	super initializeForNewSession.
	"self loadText."
       curveRenderer := nil.
       (display gl isSupportedExtension: #GL_ARB_fragment_program ) ifTrue: [
               curveRenderer := NBGLCurveRenderer new gl: display gl.
               glyphCache := NBTTFontCache new initialize: curveRenderer.
       ]! !

!GLCity methodsFor: 'accessing' stamp: 'DouailleErwan 5/7/2012 14:22'!
lastMousePosition
	^lastMousePosition! !

!GLCity methodsFor: 'accessing' stamp: 'DouailleErwan 5/7/2012 14:22'!
lastMousePosition: aPoint
	lastMousePosition := aPoint! !

!GLCity methodsFor: 'session management' stamp: 'DouailleErwan 4/18/2012 14:33'!
loadText
       curveRenderer := nil.
       (display gl isSupportedExtension: #GL_ARB_fragment_program ) ifTrue: [
               curveRenderer := NBGLCurveRenderer new gl: display gl.
               glyphCache := NBTTFontCache new initialize: curveRenderer.
       ]! !

!GLCity methodsFor: 'initialize' stamp: 'DouailleErwan 6/4/2012 16:41'!
openInWorld
	|dock container win |
	"super openInWorld setLabel:'SourceCity'."
	self startStepping.
	self takeKeyboardFocus.
	win := StandardWindow new.
	conten := ValueHolder new contents: ''.
	container :=  (win newTitle: 'Documentation' for: (
							(win newTextEditorFor: conten
							getText: #contents
							setText: #contents:) disable;minWidth: 100;minHeight: 50)).
		win
			addMorph: self
			fullFrame: (LayoutFrame fractions: (0@0 corner: 1@0.5));
			addMorph: container
			fullFrame: (LayoutFrame fractions: (0@0.5 corner: 1@1)).
		win
			themeChanged;
			title: 'SourceCity';
			openInWorld;
			width: 700;
			height: 500.! !

!GLCity methodsFor: 'camera' stamp: 'douaille 4/7/2012 16:42'!
perspectiveFovY: fovY aspect: aspect zNear: zNear zFar: zFar
"Replaces gluPerspective. Sets the frustum to perspective mode.
// fovY     - Field of vision in degrees in the y direction
// aspect   - Aspect ratio of the viewport
// zNear    - The near clipping distance
// zFar     - The far clipping distance
 "
	| fW fH |
	fH := (fovY / (360 * Float pi)) tan * zNear.
	"fH = tan( fovY / 360 * pi ) * zNear;"
	fW := fH * aspect.
	display gl frustum_left: fW negated  right:  fW bottom: fH negated top: fH  zNear:  zNear zFar:   zFar! !

!GLCity methodsFor: 'session management' stamp: 'DouailleErwan 5/22/2012 14:41'!
platformDefaultFontsPath

	NativeBoost platformId == NativeBoostConstants win32PlatformId ifTrue: [
		^ 'C:\Windows\Fonts\'
		].
	NativeBoost platformId == NativeBoostConstants mac32PlaformId ifTrue: [
		^ '/Library/Fonts/'
		].
! !

!GLCity methodsFor: 'rendering' stamp: 'DouailleErwan 5/23/2012 21:59'!
render

	| gl specular shinines l_pos l_color lmodel_ambient t fog_color diffuse spot target |
	display bindRenderBuffers.
	self checkSession.
	
	"WORK !!!!!!!!"
	"specular := GLFloatRGBA new.
	specular r: 1; g: 1;b: 1; a:1. 
	shinines:= GLFloatRGBA new.
	shinines r: 500. 	
	l_pos := GLFloatVector new.
	l_pos x: 0 ;y: 0;z: 0. 
	l_color := GLFloatRGBA new.
	l_color r: 1; g: 1;b: 1; a:1. 			
	lmodel_ambient := GLFloatRGBA new.
	lmodel_ambient r: 1;g: 1 ;b: 1; a:1."
	
	"fog_color := GLFloatRGBA new.
	fog_color r: 0.5; g: 0.5;b: 0.5; a:1. "
	
	gl := display gl.
	gl 		
		enable: GL_MULTISAMPLE ;
		enable: GL_BLEND;
		enable: GL_POLYGON_SMOOTH;
		enable: GL_NORMALIZE;
		clearDepth: 1; 
	 	enable: GL_DEPTH_TEST;
		shadeModel: GL_SMOOTH;
		hint_target: GL_LINE_SMOOTH_HINT mode: GL_FASTEST;
		hint_target: GL_POLYGON_SMOOTH_HINT mode: GL_FASTEST;
		hint_target: GL_PERSPECTIVE_CORRECTION_HINT mode: GL_NICEST;
		
		"FOG"
		"enable: GL_FOG;
		fogi_pname: GL_FOG_MODE param: GL_EXP2;
		fogfv_pname: GL_FOG_COLOR params: fog_color;
		fogf_pname: GL_FOG_DENSITY param: 0.01;
		hint_target: GL_FOG_HINT mode: GL_DONT_CARE;
		fogf_pname: GL_FOG_START param: 1.0;
		fogf_pname: GL_FOG_END param: 5.0;"
		
		"LIGHT"
		"materialfv_face: GL_FRONT pname: GL_SPECULAR params: specular;
		materialfv_face: GL_FRONT pname: GL_SHININESS  params: shinines;
		lightfv_light: GL_LIGHT0 pname: GL_POSITION params: l_pos;
		lightfv_light: GL_LIGHT0 pname: GL_DIFFUSE params: l_color;
		lightfv_light: GL_LIGHT0 pname: GL_SPECULAR params: l_color;
		lightModelfv_pname: GL_LIGHT_MODEL_AMBIENT params: lmodel_ambient;
		enable: GL_LIGHTING;
		enable: GL_LIGHT0;	"
				
		depthFunc: GL_LEQUAL;
		depthMask: true.			
	gl 
		clearColor_red: configuration glBackground red green:  configuration glBackground green blue:  configuration glBackground blue alpha: 0;
		clear: GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT.
	gl 
		matrixMode: GL_PROJECTION; 						
		loadIdentity.	
			
	self perspectiveFovY: 100.0 
			aspect: (self width /self height) asFloat 
			zNear:  0.1 zFar: 10000.0.

	gl matrixMode: GL_MODELVIEW. 						
	gl loadIdentity.	
		
	self applyCamera.
	self drawCity: model.
	gl flush.! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 5/29/2012 10:27'!
rotateDown

	configuration cameraXPos: (configuration cameraXPos + 3).
	! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 5/29/2012 10:28'!
rotateLeft

	configuration cameraYPos: (configuration cameraYPos + 3).
	! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 5/29/2012 10:28'!
rotateRight
	
	configuration cameraYPos: (configuration cameraYPos - 3).! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 5/29/2012 10:27'!
rotateTop
	configuration cameraXPos: (configuration cameraXPos - 3).! !

!GLCity methodsFor: 'stepping and presenter' stamp: 'DouailleErwan 4/23/2012 10:46'!
step
	self changed! !

!GLCity methodsFor: 'stepping and presenter' stamp: 'DouailleErwan 4/23/2012 10:46'!
stepTime
	^5! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 5/22/2012 14:45'!
translateBackward

	ztran := ztran - 3.
	
	! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 5/29/2012 15:15'!
translateDown

	ytran := ytran + 30.
	
	! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 5/29/2012 15:15'!
translateForward

	ztran := ztran + 30.
	
	! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 5/22/2012 14:45'!
translateLeft

	xtran := xtran - 3.
	
	! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 5/22/2012 14:45'!
translateRight

	xtran := xtran + 3.
	
	! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 5/22/2012 14:45'!
translateTop

	ytran := ytran - 3.
	
	! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 5/22/2012 11:16'!
vertex: array

	display gl 
		vertex3d_x: array first y: array second  z: array third! !

GLViewportMorph subclass: #GLTest
	instanceVariableNames: 'rot model face top down grass xtran ytran ztran xrot yrot zrot znumb xnumb ynumb pickingBuf'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!GLTest commentStamp: '<historical>' prior: 0!
Doing some examples in OpenGL.!

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 17:08'!
applyCamera
	display gl translatef_x: xtran y: ytran z: ztran. 
	display gl  rotatef_angle: xrot x: 1 y: 0  z: 0. 
	display gl rotatef_angle: yrot x: 0 y: 1  z: 0. 
	display gl rotatef_angle: yrot x: 0 y: 1  z: 0. 
! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 5/22/2012 15:02'!
cube_x: x y: y z: z
	|gl|
	
	gl := display gl.
	gl begin: GL_QUADS;
		pushMatrix;
		pushName: x;
		scalef_x: 3 y: 1 z: 1;
		color3f_red: 0 green: 0 blue: 1; 
		vertex3f_x: x y: 0  z: z; 
		vertex3f_x: x  y: y z: z; 
		vertex3f_x: x+1 y: y z: z; 
		vertex3f_x: x+1 y: 0 z: z; 
		
		color3f_red: 0 green: 1 blue: 0; 
		vertex3f_x: x y: 0  z: z+1; 
		vertex3f_x: x+1 y:0  z: z+1; 
		vertex3f_x: x+1 y: y z: z+1; 
		vertex3f_x: x y: y z: z+1; 
		
		color3f_red: 1 green: 0 blue: 0;
		vertex3f_x: x+1 y: 0  z: z; 
		vertex3f_x: x+1  y: y z: z; 
		vertex3f_x: x+1 y: y  z: z+1; 
		vertex3f_x: x+1 y: 0  z: z+1; 
		
		color3f_red: 1 green: 0 blue: 1; 
		vertex3f_x: x y: 0 z: z+1; 
		vertex3f_x: x y: y z: z+1; 
		vertex3f_x: x y: y  z: z; 
		vertex3f_x: x y: 0 z:z; 
		
		color3f_red: 0 green: 1 blue: 1; 
		vertex3f_x: x y: 0  z:z; 
		vertex3f_x: x+1 y: 0 z: z; 
		vertex3f_x: x+1 y: 0 z: z+1; 
		vertex3f_x: x y: 0 z: z+1; 
		
		color3f_red: 1 green: 1 blue: 0; 
		vertex3f_x: x y: y  z: z; 
		vertex3f_x: x y: y z: z+1; 
		vertex3f_x: x+1 y: y  z: z+1; 
		vertex3f_x: x+1 y: y z: z; 
		popName;
		popMatrix;

	end.
	! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 5/16/2012 17:05'!
initialize
	
	super initialize.
	xrot := 0.
	yrot := 0.
	zrot := 0.
	xtran := 0.
	ytran := 0.
	ztran := -50.
	znumb := 0.
	xnumb := 0.
	ynumb := 0.
	rot := 0.
	
	self on: #mouseDown send: #pickPixel: to: self.
	
"	pickingBuf := GLFrameBufferForPicking new initialize: display gl extent: display extent.
	pickingBuf createAttachments; checkStatus.
	"! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 17:08'!
line_x: x y: y z: z
	|gl|
	
	gl := display gl.
	
	gl begin: GL_LINES;

		color3f_red: 1 green: 0 blue: 0; 
		vertex3f_x: x y: y  z: z; 
		vertex3f_x: x+1 y: y  z: z; 

		color3f_red: 0 green: 1 blue: 0; 
		vertex3f_x: x y: y z: z; 
		vertex3f_x: x y: y+1 z: z;
		 
		color3f_red: 0 green: 0 blue: 1; 
		vertex3f_x: x y:  y z: z; 
		vertex3f_x: x y: y z: z+1;
		
	end.
	! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 17:08'!
openInWorld

	super openInWorld.
	
	self startStepping.! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 17:08'!
perspectiveFovY: fovY aspect: aspect zNear: zNear zFar: zFar
"Replaces gluPerspective. Sets the frustum to perspective mode.
// fovY     - Field of vision in degrees in the y direction
// aspect   - Aspect ratio of the viewport
// zNear    - The near clipping distance
// zFar     - The far clipping distance
 "
	| fW fH |
	fH := (fovY / (360 * Float pi)) tan * zNear.
	"fH = tan( fovY / 360 * pi ) * zNear;"
	fW := fH * aspect.
	display gl frustum_left: fW negated  right:  fW bottom: fH negated top: fH  zNear:  zNear zFar:   zFar! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 5/16/2012 17:08'!
pickPixel: e
	| x y  pixel |
	 x := (e position x) - self position x.
	 y := (e position y) - self position y.

	pixel := display readPixel: x@y.	

	Transcript cr;show: pixel printString.
	
! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 5/21/2012 09:06'!
render

	| gl |
	display bindRenderBuffers.
	self checkSession.
	gl := display gl.
		
	gl 
	      enable: GL_MULTISAMPLE;
		shadeModel: GL_SMOOTH;					
		clearDepth: 1; 
	 	enable: GL_DEPTH_TEST;
		depthFunc: GL_LEQUAL;
		depthMask: true.

	gl 
		clearColor_red: 1 green:  1 blue:  1 alpha: 0;
		clear: GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT.

	
	gl matrixMode: GL_PROJECTION; 						
		loadIdentity.	
			
	self perspectiveFovY: 45.0 
			aspect: (self width /self height) asFloat 
			zNear:  0.1 zFar: 010000.0.

	gl matrixMode: GL_MODELVIEW. 						
	gl loadIdentity.	


	self applyCamera.
	gl rotatef_angle: (rot\\360) x: 1 y: 1 z: 1.
	self line_x: 0 y: 0 z: 0.
	self cube_x: 1 y: 1 z: 1.
	gl flush.
! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 17:08'!
step
	rot := rot + 2.
	self changed! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 5/9/2012 12:34'!
stepTime
	^ 1! !

!NBGLDisplay methodsFor: '*SourceCity-OpenGL' stamp: 'DouailleErwan 5/22/2012 11:27'!
readPixel: aPoint

      |  x y pixel |
	pixel := ByteArray new: 4.

	x := aPoint x asInteger.
	y := aPoint y asInteger.
	
	"Copy pixels from buffer into a form"
	self gl flush;
		pixelStorei_pname: GL_PACK_SKIP_ROWS param: 0;
		pixelStorei_pname: GL_PACK_SKIP_PIXELS param: 0;
		
		readPixels_x: x
		y: y
		width: 1  
		height: 1  
		format: GL_BGRA_EXT 
		type:  GL_UNSIGNED_BYTE 
		pixels: pixel.

	^ pixel
	! !

NBGLFrameBuffer subclass: #GLFrameBufferForPicking
	instanceVariableNames: 'texId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!GLFrameBufferForPicking methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 5/16/2012 15:39'!
attachTexture
	texId := WordArray new: 1.
	
" Create the texture object for the primitive information buffer "
	gl genTextures_n: 1 textures: texId.
	texId := texId at: 1.

	gl bindTexture_target: GL_TEXTURE_2D texture: texId.

	gl texImage2D_target:  GL_TEXTURE_2D level: 0  internalformat:  GL_RGB32UI 
		width: extent x  height: extent y border: 0  format: GL_RGB_INTEGER type: GL_UNSIGNED_INT pixels: nil.
	
	gl framebufferTexture2DEXT_target:  GL_DRAW_FRAMEBUFFER 
		attachment:  GL_COLOR_ATTACHMENT0 
		textarget: GL_TEXTURE_2D 
		texture:  texId  
		level: 0	.
	
	self assert: (gl getError = 0).
	gl bindTexture_target: GL_TEXTURE_2D texture: 0.! !

!GLFrameBufferForPicking methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 5/16/2012 15:21'!
createAttachments

		" By default, create a RGBA8 and DEPTH24/STENCIL8 attachments "
	| color depthAndStencil |
	
	self attachTexture.

	
	depthAndStencil := NBGLRenderBuffer gl: gl extent: extent format: GL_DEPTH24_STENCIL8.
	self attach: depthAndStencil as: GL_DEPTH_ATTACHMENT.
	self attach: depthAndStencil as: GL_STENCIL_ATTACHMENT.
	
! !

!GLFrameBufferForPicking methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 5/16/2012 15:23'!
resize: newExtent

	"resize a frame buffer"
	extent = newExtent ifTrue: [ ^ self ].
	extent := newExtent.	

	self attachments do: [:renderBuffer | renderBuffer resize: newExtent  ].
	self resizeTexture.
	self checkStatus.

! !

!GLFrameBufferForPicking methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 5/16/2012 15:23'!
resizeTexture

	gl bindTexture_target: GL_TEXTURE_2D texture: texId.

	gl texImage2D_target:  GL_TEXTURE_2D level: 0  internalformat:  GL_RGB32UI 
		width: extent x  height: extent y border: 0  format: GL_RGB_INTEGER type: GL_UNSIGNED_INT pixels: nil.
! !

!NBMSAAOffscreenDisplay methodsFor: '*SourceCity-OpenGL' stamp: 'DouailleErwan 5/22/2012 11:35'!
readPixel: aPoint
	| r |

	renderFBO bindAsReadBuffer.
	resultsFBO bindAsDrawBuffer.
	
	self gl blitFramebuffer_srcX0: 0 srcY0:  0 srcX1: extent x srcY1: extent y 
		dstX0:  0 dstY0:  0 dstX1: extent x  dstY1: extent y mask: GL_COLOR_BUFFER_BIT filter: GL_NEAREST.
	
	resultsFBO bindAsReadBuffer.
		
	r := super readPixel: aPoint.
	^ r! !

NBExternalStructure variableByteSubclass: #GLCityStructure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!GLCityStructure class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 13:38'!
fieldsDesc
  ^ #( 
         float r;
         float g;
         float b;
         float a;
        )! !

NBExternalStructure variableByteSubclass: #GLFloatRGBA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!GLFloatRGBA class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 16:13'!
fieldsDesc
  ^ #( 
         NBGLFloat r;
         NBGLFloat g;
         NBGLFloat b;  
	   NBGLFloat a;      
        )! !

NBExternalStructure variableByteSubclass: #GLFloatShinines
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!GLFloatShinines class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 16:13'!
fieldsDesc
  ^ #( 
         NBGLFloat  r;
        )! !

NBExternalStructure variableByteSubclass: #GLFloatVector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!GLFloatVector commentStamp: '<historical>' prior: 0!
For initializing x, y, z!

!GLFloatVector class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 16:14'!
fieldsDesc
  ^ #( 
         NBGLFloat x;
         NBGLFloat y;
         NBGLFloat z;  
        )! !
